!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Subroutine AdvectScalar_MPDATA
!
!   * Developer: ODAKA Masatsugu (odakker@gfd-dennou.org)
!   * Version: $Id: advectscalar_mpdata.f90,v 1.3 2005/02/18 06:51:38 odakker Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
! 顼̤ΰή MPDATA ѤƷ׻. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
! Թ, ʬʺʬѤƹԤ.
! °Ϥѿλ֥٥դ뤳.
!
! ήξ,  fs_VelX, fs_VelZ λ֥٥ ss_Scalar 
! ֥٥뤫 DelTime/2 ԤΤˤ.
!
! ®پ leapfrog ǲ򤯾˴ñ˼ʤ,  t ˤ
! fs_VelX_n, fs_VelZ_n Ѥƻֹ 2*DelTime ʺʬȤ ss_Scala
! ʬ.
!
!       t-t           t           t+t
!    -----|-------------|-------------|-----
!             [fs_VelX_n,sf_VelZ_n]
!    ss_Scalar_b                  ss_Scalar_a 
!         |======== 2*DelTime =======>|
!
!
! ɤ׻ʤ t+t/2 ˤ fs_VelX_mid, sf_VelZ_mid  
! Ѥƻֹ DelTime ʺʬȤ ss_Scalar ׻.
!
!       t-t           t           t+t
!    -----|-------------|------|------|-----
!                   [fs_VelX_mid,sf_VelZ_mid]
!                   s_Scalar_n   ss_Scalar_a 
!                       |== DelTime =>|
!
!== Future Plans
!
                                                                 !=end
subroutine AdvectScalar_MPDATA(fs_VelX, sf_VelZ, &
&                              ss_Scalar, DelTime, ss_AdvScalar)
                                                                 !=begin
  !== Dependency
  use dc_trace,      only: BeginSub, EndSub 
  use gridset,       only: DimXMin, DimXMax, DimZMin, DimZMax, DelX, DelZ
  use average,       only: fs_avr_sf, sf_avr_fs, sf_avr_ss, fs_avr_ss
  use differentiate, only: fs_dx_ss, sf_dz_ss, ss_dx_fs, ss_dz_sf
  use bcset,         only: ss_BC, sf_BC, fs_BC
                                                                 !=end  
  !--- ۤηػ
  implicit none
                                                                 !=begin
  !== Input
  real(8), intent(in)  :: fs_VelX(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: sf_VelZ(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: ss_Scalar(DimXMin:DimXMax, DimZMin:DimZMax)
  real(8), intent(in)  :: DelTime

  !== Output
  real(8), intent(out) :: ss_AdvScalar(DimXMin:DimXMax, DimZMin:DimZMax)
                                                                 !=end

  !== Work
  real(8) :: ss_Scalar_tmp(DimXMin:DimXMax, DimZMin:DimZMax)   ! 
  real(8) :: ss_AdvScalar_tmp(DimXMin:DimXMax, DimZMin:DimZMax)! 
  real(8) :: ss_DivVel(DimXMin:DimXMax, DimZMin:DimZMax)       ! ȯ
  real(8) :: fs_FluxX(DimXMin:DimXMax, DimZMin:DimZMax)        ! եå
  real(8) :: sf_FluxZ(DimXMin:DimXMax, DimZMin:DimZMax)        ! եå
  real(8) :: fs_AntiDiffVelX(DimXMin:DimXMax, DimZMin:DimZMax) ! ȿȻ®
  real(8) :: sf_AntiDiffVelZ(DimXMin:DimXMax, DimZMin:DimZMax) ! ȿȻ®
  real(8) :: fs_AntiDiffFluxX(DimXMin:DimXMax, DimZMin:DimZMax)! եå
  real(8) :: sf_AntiDiffFluxZ(DimXMin:DimXMax, DimZMin:DimZMax)! եå


  call BeginSub("AdvectScalar_MPDATA", &
&               fmt="%c",       &
&          c1="Calculate advection term for scalar variables (ss_AdvScalar).")

  !--- 

  fs_FluxX = 0.0d0 ; sf_FluxZ = 0.0d0 ; ss_AdvScalar = 0.0d0

  !--- ήʬˡѤƥ顼Υեå׻

  call FluxScalar(fs_VelX, sf_VelZ, ss_Scalar, fs_FluxX, sf_FluxZ)


  !--- ȯη׻

  call DivergenceVel(fs_VelX, sf_VelZ, ss_DivVel)


  !--- ήˤʬ׻

  ss_AdvScalar = ss_dx_fs(fs_FluxX) + ss_dz_sf(sf_FluxZ)  
!&                - ss_Scalar * ss_DivVel

  !--- 顼βͤ׻

  call Integral(- ss_AdvScalar, DelTime, ss_Scalar, ss_Scalar_tmp )
  call boundary(ss_BC, ss_Scalar_tmp)


  !--- MPDATA ˤ

  !--- 

  fs_AntiDiffVelX  = 0.0d0 
  sf_AntiDiffVelZ  = 0.0d0
  fs_AntiDiffFluxX = 0.0d0 
  sf_AntiDiffFluxZ = 0.0d0
  ss_AdvScalar_tmp = 0.0d0
  ss_DivVel        = 0.0d0
 

  !--- ήʬˤ륹顼եå 0 ǤʤȿȻ®٤׻

  where(fs_FluxX /= 0.0d0)

    fs_AntiDiffVelX = 0.5d0 * (                                               &
&     (abs(fs_VelX)*DelX - DelTime*fs_VelX**2)*fs_dx_ss(ss_Scalar_tmp)        &
&    - DelTime*fs_VelX*fs_avr_sf(sf_VelZ)*fs_avr_sf(sf_dz_ss(ss_Scalar_tmp))) &
&     / (Max(fs_avr_ss(ss_Scalar_tmp), epsilon(0.0d0)))                       &
&    - 0.5d0*fs_VelX*fs_avr_ss(ss_DivVel)

  end where

  where (sf_FluxZ /= 0.0d0) 

    sf_AntiDiffVelZ = 0.5d0 * (                                               &
&     (abs(sf_VelZ)*DelZ - DelTime*sf_VelZ**2)*sf_dz_ss(ss_Scalar_tmp)        &
&    - DelTime*sf_VelZ*sf_avr_fs(fs_VelX)*sf_avr_fs(fs_dx_ss(ss_Scalar_tmp))) &
&     / (MAX(sf_avr_ss(ss_Scalar_tmp), epsilon(0.0d0)))                       &
&    - 0.5d0*sf_VelZ*sf_avr_ss(ss_DivVel)

  end where

  !--- ȿȻ®٤ˤ͢
  ! ȿȻ®٤ºݤ®٤ۤƤͤ 0 ˤ.

  where(abs(fs_AntiDiffVelX) > abs(fs_VelX) )
;    fs_AntiDiffVelX = 0.0d0
  end where

  where(abs(sf_AntiDiffVelZ) > abs(sf_VelZ) )
    sf_AntiDiffVelZ = 0.0d0
  end where


  !--- ȿȻ®٤ȾήʬˡѤƥ顼Υեå׻

  call FluxScalar(fs_AntiDiffVelX, sf_AntiDiffVelZ, ss_Scalar_tmp, &
&                 fs_AntiDiffFluxX, sf_AntiDiffFluxZ) 

  !--- ȿȻ®٤ΰήˤʬ׻
  ss_AdvScalar_tmp = ss_dx_fs(fs_AntiDiffFluxX) + ss_dz_sf(sf_AntiDiffFluxZ)


  !--- ʬ׻
  ss_AdvScalar = ss_AdvScalar_tmp + ss_AdvScalar

  call EndSub("AdvectScalar_MPDATA")

  contains

  !--- ήʬˡѤƥ顼Υեå׻

  subroutine FluxScalar(fs_VelX, sf_VelZ, ss_Scalar, &
&                       fs_FluxX, sf_FluxZ)

    real(8), intent(in)  :: fs_VelX(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(in)  :: sf_VelZ(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(in)  :: ss_Scalar(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(out) :: fs_FluxX(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8), intent(out) :: sf_FluxZ(DimXMin:DimXMax, DimZMin:DimZMax)
   

    fs_FluxX(DimXMin:DimXMax-1, :) =  (&
&      (fs_VelX(DimXMin:DimXMax-1, :) + abs(fs_VelX(DimXMin:DimXMax-1, :))) &
&              *ss_Scalar(DimXMin:DimXMax-1, :)       &
&     +(fs_VelX(DimXMin:DimXMax-1, :) - abs(fs_VelX(DimXMin:DimXMax-1, :))) &
&              *ss_Scalar(DimXMin+1:DimXMax, :) )*0.5d0

    sf_FluxZ(:, DimZMin:DimZMax-1) =  (& 
&       (sf_VelZ(:, DimZMin:DimZMax-1) + abs(sf_VelZ(:, DimZMin:DimZMax-1))) &
&              *ss_Scalar(:, DimZMin:DimZMax-1)       &
&     + (sf_VelZ(:, DimZMin:DimZMax-1) - abs(sf_VelZ(:, DimZMin:DimZMax-1))) &
&              *ss_Scalar(:, DimZMin+1:DimZMax) )*0.5d0


  end subroutine FluxScalar
  
end subroutine AdvectScalar_MPDATA

